#include "pktfec.h"
#include "generator.c"
#include "check.c"

#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>

int main(int argc, char **argv) {
  uint8_t buffer[PKTFEC_BLOCKLEN];
  int i, j, k;
  for (i=0; i<8*PKTFEC_BLOCKDATALEN; i++) {
    fprintf(stdout, "Testing bit %i\n", i);
    for (j=0; j<PKTFEC_BLOCKLEN; j++) buffer[j] = 0;
    buffer[i/8] |= 0x80 >> (i%8);
    for (j=0; j<PKTFEC_BLOCKFECLEN; j++) {
      buffer[PKTFEC_BLOCKDATALEN+j] = pktfec_generator[PKTFEC_BLOCKFECLEN*i+j];
    }
    for (j=0; j<8*PKTFEC_BLOCKFECLEN; j++) {
      int t = 0;
      //fprintf(stdout, "Check %i\n", j);
      for (k=0; pktfec_checks[j][k] >= 0; k++) {
        int bit = pktfec_checks[j][k];
        //fprintf(stdout, "Bit %i\n", k);
        if (buffer[bit/8] & (0x80 >> (bit%8))) t ^= 1;
      }
      if (t) abort();
    }
  }
  return 0;
}
