#!/usr/bin/env lua
f1 = assert(io.open("test.data"))
f2 = assert(io.open("/dev/stdin"))
errors = 0
while true do
  b1 = f1:read(1)
  if not b1 then break end
  b2 = f2:read(1)
  if not b2 then
    print("Length not matching")
    return
  end
  n1 = string.byte(b1)
  n2 = string.byte(b2)
  for i = 0, 7 do
    local mask = 1 << i
    if ((n1 & mask) ~ (n2 & mask)) ~= 0 then
      errors = errors + 1
    end
  end
end
print(errors)
